# Prisma Dart client v4.0.0-alpha.1

To install Prisma Dart client v4.0.0-alpha.0 run:

```sh
dart pub add orm:4.0.0-alpha.1
```

Or update your `pubspec.yaml` file:

```yaml
dependencies:
  orm: 4.0.0-alpha.1
```

## What's Changed

1. Refactor the entire client generator
2. `PrismaClient` is now generated by the generator
3. Ability to operate transactions on your own
4. Use binary engine by default
5. Supports full select and include features.

# Prisma Dart client v4.0.0-alpha.0

To install Prisma Dart client v4.0.0-alpha.0 run:

```sh
# If you are using Dart
dart pub add orm:4.0.0-alpha.0

# Or if you are using Flutter
flutter pub add orm:4.0.0-alpha.0
```

To upgrade to Prisma Dart client v4.0.0-alpha.0, Please follow the [announcements](https://github.com/medz/prisma-dart/discussions/292) and update your `pubspec.yaml` file:

```yaml
dependencies:
  orm: 4.0.0-alpha.0
```

[Read Prisma Dart Client v4.0.0-alpha.0 release notes on the Prisma Dart discussions](https://github.com/medz/prisma-dart/discussions/292)

## What's Changed

- Whole project refactoring
- Remove any JSON serialization tool, now it's ready to use by just generating the client without any other dependencies and extra commands
- Switch from GraphQL protocol to JSON protocol
- Client takes a standalone Prisma engine instance
- Client and all input/output types are standalone and can be distributed to any Dart platform
- Add database field reference support
- Support `select` feature (incomplete, currently only support rough one-level Model fields)
- Support `include` feature (incomplete, currently only support rough one-level Model fields)
- `PrismaUnion` regression, now can structure nested inputs of multiple parameters via union
- `PrismaNull` regression, now support database `null` data setting
- DMMF, generator helpers regression, no need to depend on other packages, can directly use `orm` as the base package for developing Dart Prisma ecosystem packages
- Add `Decimal` type support (from [decimal package](https://pub.dev/package/decimal), exported by `orm` proxy)
